# -*- coding: utf-8 -*-
"""
Created on Tue Jun 23 17:32:50 2020

@author: DaasJ
"""
import arcpy
from createMeasureContour import *
from arcpy import env  
from arcpy.sa import *
import settings
from generalFunctions import *
import os

def AddError(message):
    #print('Error: ' + message)
    arcpy.AddError(message)

if __name__ == '__main__':
    
    if arcpy.CheckExtension("Spatial") == "Available":
        arcpy.CheckOutExtension("Spatial")
    else:
       AddError("Spatial Analyst not available") 
    
    
    gdb = arcpy.GetParameterAsText(0)
    geombound = arcpy.GetParameterAsText(1)
    print(geombound)
    env.workspace=os.path.join(gdb,r"baseline.gdb/elevation")
    env.overwriteOutput=True
    inpoints=["surfacelevel_points","bedlevel_points","waterbody_bedlevel_points"]
    inlines=["terrain_jump_3d_routes","terrain_edge_3d_lines"]
    
    addlines=[]
    addpoints=[]

    for fc in inpoints:
        if arcpy.Exists(fc) and arcpy.management.GetCount(fc)[0] != "0":
            if "points" in fc:
                addpoints.append([fc,"ELEVATION"])
            else:
                addpoints.append([fc])

    for fc in inlines:
        if arcpy.Exists(fc) and arcpy.management.GetCount(fc)[0] != "0":
            out=arcpy.CopyFeatures_management(fc,"in_memory\{}".format(fc))
            arcpy.AddField_management(out, "ELEVATION", "DOUBLE")
            arcpy.AddGeometryAttributes_management(out, "LINE_START_MID_END")
            addlines.append([out,"MID_Z"])
        

    
    if geombound:
        addfc=[TopoContour(addlines),TopoPointElevation(addpoints),TopoBoundary([geombound])]
    else:
        addfc=[TopoContour(addlines),TopoPointElevation(addpoints)]
    


    
    topo = TopoToRaster(addfc,enforce="NO_ENFORCE")    
    if geombound:
        topo=ExtractByMask(topo, geombound)
    topo.save(os.path.join(gdb,"baseline.gdb/elevation_raster"))
    arcpy.CheckInExtension("Spatial")