# -*- coding: utf-8 -*-
"""
Created on Wed Aug 12 12:04:09 2020

@author: DaasJ
"""

import arcpy
import os

baseline = arcpy.GetParameterAsText(0)
ecotopen=arcpy.GetParameterAsText(1)
field=arcpy.GetParameterAsText(2)
measure=arcpy.GetParameterAsText(3)
key="landuse_key.csv"
#ecotopen=r"C:\Baseline\EcotopenTool\Input\Ecotopen_Vechtstromen_3_feb_2017.shp"
#veld="CODE"
#baseline=r"C:\Baseline\refx\ref"
#sleutel="C:\Baseline\EcotopenTool\Input\Sleutel.csv"

measureGDB=os.path.join(measure,"baseline.gdb")
gdb = os.path.join(baseline,"baseline.gdb")
landuse = os.path.join("roughness\land_use_polygons")
arcpy.env.workspace=gdb
arcpy.env.overwriteOutput=True
calib = os.path.join("models\calibration_section_input_polygons.")
unicalib = arcpy.Frequency_analysis(calib, "calib",["CALIBRATION_CODE"])
codelist=[1, 102, 103, 104, 105, 106, 201, 302, 303, 304, 305]
with arcpy.da.SearchCursor(unicalib,"CALIBRATION_CODE") as sc:
    for row in sc:
            codelist.append(row[0])

lyr=arcpy.MakeFeatureLayer_management(landuse,"landuselyr")
arcpy.SelectLayerByAttribute_management("landuselyr", "NEW_SELECTION", '''ROUGHNESS_CODE in {}'''.format(tuple(codelist)))
arcpy.CopyFeatures_management(lyr, "landuselyr1")

arcpy.MakeFeatureLayer_management(ecotopen, "veg_layer")
arcpy.AddJoin_management("veg_layer", field, key, "CODE", "KEEP_COMMON")
arcpy.CopyFeatures_management("veg_layer", "veglyr")
arcpy.Erase_analysis("veglyr","landuselyr","erase")

in_file = "erase"
output_file = os.path.join(measureGDB,r"roughness\land_use_polygons")
fm_type = arcpy.FieldMap()
fm_char = arcpy.FieldMap()
fms = arcpy.FieldMappings()

# Get the field names of vegetation type and diameter for both original
# files
eco_type ="landuse_key_csv_ROUGHNESS_CODE"
eco_char = "landuse_key_csv_CODE"

# Add fields to their corresponding FieldMap objects
fm_type.addInputField(in_file, eco_type)
fm_char.addInputField(in_file, eco_char)

# Set the output field properties for both FieldMap objects
type_name = fm_type.outputField
type_name.name = 'ROUGHNESS_CODE'
type_name.aliasName= 'ROUGHNESS_CODE'
fm_type.outputField = type_name

char_name = fm_char.outputField
char_name.name = 'CHARACTERISTICS'
char_name.aliasName = 'CHARACTERISTICS'
char_name.length = 100
fm_char.outputField = char_name


fms.addFieldMap(fm_type)
fms.addFieldMap(fm_char)

# Merge the two feature classes
arcpy.Merge_management([in_file], output_file, fms)

#Cleanup
arcpy.Delete_management("landuselyr")
arcpy.Delete_management("landuselyr1")
arcpy.Delete_management(unicalib)
arcpy.Delete_management("erase")
arcpy.Delete_management("veglyr")
